function CSUI(CSLibrary) {
  if (!CSLibrary) {
    return null;
  }

  this.CSLibrary = CSLibrary;

  this.invertColor = function (rgb, bw) {
    var r = rgb[0],
      g = rgb[1],
      b = rgb[2];
    if (bw) {
      return r * 0.299 + g * 0.587 + b * 0.114 > 186 ? "#000000" : "#FFFFFF";
    }
    r = 255 - r;
    g = 255 - g;
    b = 255 - b;

    r = r < 128 ? r - 72 : r + 72;
    g = g < 128 ? g - 72 : g + 72;
    b = b < 128 ? b - 72 : b + 72;

    r = r < 0 ? 0 : r;
    g = g < 0 ? 0 : g;
    b = b < 0 ? 0 : b;

    r = r > 255 ? 255 : r;
    g = g > 255 ? 255 : g;
    b = b > 255 ? 255 : b;

    return "rgb(" + [r, g, b].join(", ") + ")";
  };

  this.hoverColor = function (rgb) {
    var r = rgb[0],
      g = rgb[1],
      b = rgb[2];
    if (r + g + b <= 669) {
      r = r + 32;
      g = g + 32;
      b = b + 32;
    } else {
      r = r - 32;
      g = g - 32;
      b = b - 32;
    }
    r = r < 0 ? 0 : r;
    g = g < 0 ? 0 : g;
    b = b < 0 ? 0 : b;
    r = r > 255 ? 255 : r;
    g = g > 255 ? 255 : g;
    b = b > 255 ? 255 : b;
    return "rgb(" + [r, g, b].join(", ") + ")";
  };

  this.getColorEnv = function () {
    var hostEnv = this.CSLibrary.getHostEnvironment();
    var UIColorObj = new UIColor();
    UIColorObj = hostEnv.appSkinInfo.appBarBackgroundColor;
    return {
      red: Math.round(UIColorObj.color.red),
      green: Math.round(UIColorObj.color.green),
      blue: Math.round(UIColorObj.color.blue),
      alpha: Math.round(UIColorObj.color.alpha),
    };
  };

  this.changeThemeColor = function () {
    var root = document.querySelector(":root");
    var env = this.getColorEnv();
    var rgb = [env.red, env.green, env.blue];
    var back = "rgb(" + rgb.join(", ") + ")";
    root.style.setProperty("--back", back);
    root.style.setProperty("--invert", this.invertColor(rgb));
    root.style.setProperty("--hover", this.hoverColor(rgb));
  };
}
